<script setup lang="ts">
import { ref, watch } from 'vue'
import ThreeContextWrapper from '../components/Main/ThreeContextWrapper.vue';
import ContextMenu from '../components/Main/ContextMenu.vue';
import MainHeading from '../components/Main/MainHeading.vue';
import { useRoute, useRouter } from 'vue-router';

const openDrawer = ref(true)

const selectableChildren = ref<string[]>([])

const route = useRoute();
const router = useRouter();
let routePath = route.params.path ?? [];
if(!Array.isArray(routePath)) {
	routePath = routePath.split(".");
}
const treePath = ref<string[]>(routePath);

watch( ()=>route.params, (val, old) => {
	if(!!val.path && !Array.isArray(val.path)) {
		const path = val.path.split(".");
		treePath.value = path;
	}
	else {
		// Go for the root
		treePath.value = []
	}
})

const handleNewNodeSelectedEvent = (data: string[]) => {
    treePath.value = data;
	router.push({
		name: "App",
		params: {path: data.join(".")}
	});
}

const handleNewSelectableChildrenEvent = (childrenIds: string[]) => {
	selectableChildren.value = [...childrenIds];
}

</script>


<template>
<MainHeading :tree-path="treePath" @tree-path-changed-event="handleNewNodeSelectedEvent" :selectable-children="selectableChildren" />

<QFab :active="openDrawer" icon="chevron_left" active-icon="chevron_right" color="primary" class="fixedFab" @click="openDrawer=!openDrawer" />

<ThreeContextWrapper @new-node-selected-event="handleNewNodeSelectedEvent" :treePath="treePath"  @new-selectable-children-event="handleNewSelectableChildrenEvent"/>
<ContextMenu :is-shown="openDrawer" :path="treePath"/>
</template>

<style scoped lang="scss">
.fixedFab {
    position: fixed;
    bottom: 0vh;
    right: 0vw;
    margin-right: 10px;
    margin-bottom: 10px
}
</style>
